# Load the C-based binding.
begin
  RUBY_VERSION =~ /(\d+\.\d+\.\d+)/
  require "#{Regexp.last_match(1)}/blackfire.so"
rescue LoadError
  require "blackfire.so"
end

require "blackfire/bfyaml"
require "blackfire/call_tree"
require "blackfire/config"
require "blackfire/logger"
require "blackfire/measurement"
require "blackfire/method_info"
require "blackfire/profile"
require "blackfire/profiler"
require "blackfire/protocol"
require "blackfire/query"
require "blackfire/rack"
require "blackfire/thread"
require "blackfire/version"
module Blackfire
  class << self
    def inside_rails?
      defined?(::Rails) && defined?(::Rails::VERSION) && ::Rails::VERSION::MAJOR.to_i >= 4
    end
  end

  autoload :AbstractPrinter, "blackfire/printers/abstract_printer"
  autoload :BlackfireTracesPrinter, "blackfire/printers/blackfire_traces_printer"
  autoload :InstallGenerator, "generators/blackfire/install_generator" if inside_rails?

  Config.initialize
  Logger.initialize
end
