module Blackfire
  module BlackfireYAML
    class << self
      def must_be_sent?(data)
        items = data.split("\n")
        items.each do |item|
          next unless item.start_with? "Blackfire-Response".freeze

          item.slice! "Blackfire-Response: "
          sub_items = item.split("&").map { |i| i.split("=") }
          bf_yaml = sub_items.to_h["blackfire_yml".freeze]
          return true if bf_yaml == "true"
        end
        false
      end

      def send_file(profiler)
        path = blackfire_yaml_path
        if path.empty?
          profiler.publish "Blackfire-Yaml-Size: 0\n"
        else
          data = File.read path
          profiler.publish "Blackfire-Yaml-Size: #{data.bytesize}\n"
          profiler.publish data
        end
      end

      def defined?
        Query.flag_yml == "1"
      end

      private

      def blackfire_yaml_path
        d = Dir.pwd
        loop do
          return "#{d}/.blackfire.yaml" if File.exist? "#{d}/.blackfire.yaml"
          return "#{d}/.blackfire.yml" if File.exist? "#{d}/.blackfire.yml"
          return "" if d == "/"

          d = File.expand_path("..", d)
        end
      end
    end
  end
end
