module Blackfire
  # The Measurement class is a helper class used by Blackfire::MethodInfo to store information about the method.
  # You cannot create a CallTree object directly, they are generated while running a profile.
  class Measurement
    def children_time
      total_time - self_time - wait_time
    end

    def to_s
      "c: #{called}, tt: #{total_time}, st: #{self_time}"
    end

    def inspect
      super + "(#{self})"
    end
  end
end
